<template>
  <div>
    <div class="controls">
      <template v-if="!gameOver">
        <button @click="start" :disabled="playing" class="start" type="button" tabindex="-1">
          <template v-if="gameEverStarted">
            Resume
          </template>
          <template v-else>
              Start
          </template>
        </button>
        <button @click="pause" :disabled="!playing" class="pause" type="button" tabindex="-1">
          Pause
        </button>
        <button @click="showHelp" class="help" type="button" tabindex="-1">
          Help
        </button>
      </template>
      <template v-else>
        <button @click="reset" class="reset" type="button" tabindex="-1">
          Reset
        </button>
      </template>
    </div>
    <div v-if="helpModal" class="helpModal">
      <div class="wrapper">
        <button @click="closeHelp" class="closeModal" type="button">
          x
        </button>
        <div>
          Move the falling objects with arrow keys(Left and Right) to keep the SeeSaw in balance.
          <br>
          If there would be an extra 20KG on one side, The Game will be over.
          <br> <br>
          Enjoy!
        </div>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.controls {
  position: fixed;
  top: 5px;
  left: 5px;
  z-index: 99;
}
.start, .pause, .reset, .help {
  padding: 10px 20px;
  cursor: pointer;
  font-weight: bold;
  background-color:lightseagreen;
  color:white;
  border: 1px solid gray;
  border-radius: 3px;
  &:disabled {
    background-color: gray;
    cursor: initial;
  }
}
.start, .pause {
  margin-right: 5px;
}
.helpModal {
  z-index: 100;
  position: fixed;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  background-color:rgba(0, 0, 0, .8);
  .wrapper {
    position: relative;
    width: 800px;
    margin: auto;
    margin-top: 30px;
    padding: 30px;
    border-radius: 3px;
    background-color:white;
  }
}
.closeModal {
  position: absolute;
  top: -25px;
  left: -25px;
  width: 50px;
  height: 50px;
  padding: 0;
  font-size: 20px;
  border: 1px solid gray;
  border-radius: 100px;
  background-color:white;
  cursor: pointer;
}
</style>

<script>
import { mapState, mapActions } from 'vuex';

export default {
  name: 'controls',
  methods: {
    ...mapActions({
      start: 'startTheGame',
      pause: 'pauseTheGame',
      reset: 'resetTheGame'
    }),
    showHelp() {
      this.helpModal = true;
    },
    closeHelp() {
      this.helpModal = false;
    }
  },
  computed: mapState([
    'playing',
    'gameEverStarted',
    'gameOver'
  ]),
  data() {
    return {
      helpModal: false
    };
  }
}
</script>